import java.awt.event.*;
import javax.swing.*;

public class Control
{
	public final int f = 20; // Gre fr ein Quadrat
	public final int breite = 30; // Breite in Quadraten
	public final int hoehe = 30; // Hhe in Quadraten
	public ZEICHENFENSTER zf;
	public Gitter gitter;
	public JButton bauf, bab, blinks, brechts, bstart, bstop;
	public Schlange s;
	private Timer uhr;
	private Essen essen;
	private boolean laeuft = false;
	
	public Control()
	{
		zf = ZEICHENFENSTER.gibFenster();
		zf.setzeTitel("Snake");
		zf.setzeMasse(breite * f, hoehe * f);
		
		bauf = new JButton("auf");
		bab = new JButton("ab");
		blinks = new JButton("links");
		brechts = new JButton("rechts");
		bstart = new JButton("Start");
		bstop = new JButton("Stop");
		
		zf.komponenteHinzufuegen(bauf, "rechts");
		zf.komponenteHinzufuegen(bab, "rechts");
		zf.komponenteHinzufuegen(blinks, "rechts");
		zf.komponenteHinzufuegen(brechts, "rechts");
		zf.komponenteHinzufuegen(bstart, "rechts");
		zf.komponenteHinzufuegen(bstop, "rechts");
		
		gitter = new Gitter(breite, hoehe, f);
		gitter.zeichneGitter();
		
		setzButtons(false);
		
		bstart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				startSpiel();
			}
		});
		
		bstop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				uhr.stop();
				setzButtons(false);
			}
		});
	}
	
	public void setzButtons(boolean spiel_laeuft)
	{
		laeuft = spiel_laeuft;
		if(spiel_laeuft)
		{
			bauf.setEnabled(true);
			bab.setEnabled(true);
			brechts.setEnabled(true);
			blinks.setEnabled(true);
			bstart.setEnabled(false);
			bstop.setEnabled(true);
		}
		else
		{
			bauf.setEnabled(false);
			bab.setEnabled(false);
			brechts.setEnabled(false);
			blinks.setEnabled(false);
			bstart.setEnabled(true);
			bstop.setEnabled(false);
		}
	}
	
	public void startSpiel()
	{
		setzButtons(true);
		zf.loescheAlles();
		gitter.zeichneGitter();
		
		s = new Schlange(breite/2, hoehe/2);
		s.setzRichtung((int)(Math.random() * 4));
		essen = new Essen(breite, hoehe);
		
		bauf.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent j)
			{
				s.setzRichtung(0);
			}
		});
		
		bab.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent j)
			{
				s.setzRichtung(2);
			}
		});
		
		blinks.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent j)
			{
				s.setzRichtung(3);
			}
		});
		
		brechts.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent j)
			{
				s.setzRichtung(1);
			}
		});
		
		uhr = new Timer(500, new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				tick();
			}
		});
		
		uhr.start();
	}
	
	public void tick()
	{
		s.bewege();
		
		int[] s_kopf = s.gibKopf();
		// raus und wieder reinfahren
		if(s_kopf[0] < 0)
		{
			s.setzKopf(breite, s_kopf[1]);
		}
		if(s_kopf[0] > breite)
		{
			s.setzKopf(0, s_kopf[1]);
		}
		if(s_kopf[1] < 0)
		{
			s.setzKopf(s_kopf[0], hoehe);
		}
		if(s_kopf[1] > hoehe)
		{
			s.setzKopf(s_kopf[0], 0);
		}
		
		
		// Schlange isst
		if(s_kopf[0] == essen.x && s_kopf[1] == essen.y)
		{
			s.verlaengern();
			essen = new Essen(breite, hoehe);
		}
		
		// Essen zeichen
		gitter.fuelleQuadrat(essen.x, essen.y, 2);
		
		// Schlange zeichnen
		int[][] k_schlange = s.gibAlleKasten();
		for(int a = s.gibLaenge() -1; a >= 0; a--)
		{
			gitter.fuelleQuadrat(k_schlange[a][0], k_schlange[a][1], 5);
		}
		int [] letzter_kasten = s.gibGeloeschtenKasten();
		gitter.leereQuadrat(letzter_kasten[0], letzter_kasten[1]);
	}
}
