public class Schlange
{
	public final static int MAX_LAENGE = 100;
	private int laenge = 1;
	private int [][] kasten = new int[MAX_LAENGE][2];
	private int [] letzter_kasten = new int[2];
	private boolean verlaengern = false;
	private int richtung = 1;
	
	public Schlange(int x, int y)
	{
		// Werte initialisieren
		for(int i = 0; i < MAX_LAENGE; i++)
		{
			kasten[i][0] = -1;
			kasten[i][1] = -1;
		}
		letzter_kasten[0] = -1;
		letzter_kasten[1] = -1;
		
		// erste Position der Schlange setzen
		setzKopf(x, y);
		
	}
	
	public void setzKopf(int x, int y)
	{
		kasten[0][0] = x;
		kasten[0][1] = y;
	}
	
	public void setzRichtung(int neue_richtung)
	{
		if(richtung <= 3 && richtung >= 0 && neue_richtung != gegenRichtung(richtung))
		{
			richtung = neue_richtung;
		}
	}
	public void verlaengern()
	{
		verlaengern = true;
	}
	
	public void bewege()
	{
		bewege(richtung, verlaengern);
		if(verlaengern == true)
		{
			verlaengern = false;
		}
	}
	
	/*
	 * richtungen:
	 * 0 = oben
	 * 1 = rechts
	 * 2 = unten
	 * 3 = links
	 */
	public void bewege(int richtung)
	{
		bewege(richtung, false);
	}
	
	public void bewege(int richtung, boolean verlaengern)
	{
		// kasten nach hinten verschieben
		for(int i = laenge; i > 0; i--)
		{
			kasten[i][0] = kasten[i - 1][0];
			kasten[i][1] = kasten[i - 1][1];
		}
		
		// Kopf neu setzen
		if(richtung == 0)
		{
			kasten[0][1] = kasten[0][1] -1;
		}
		else if(richtung == 1)
		{
			kasten[0][0] = kasten[0][0] +1;
		}
		else if(richtung == 2)
		{
			kasten[0][1] = kasten[0][1] +1;
		}
		else if(richtung == 3)
		{
			kasten[0][0] = kasten[0][0] -1;
		}
		
		if(!verlaengern)
		{
			letzter_kasten[0] = kasten[laenge][0];
			letzter_kasten[1] = kasten[laenge][1];
			
			// letzten kasten abschneiden
			kasten[laenge][0] = -1;
			kasten[laenge][1] = -1;
		}
		else
		{
			if(laenge < MAX_LAENGE -1)
			{
				laenge++;
			}
			letzter_kasten[0] = -1;
			letzter_kasten[1] = -1;
		}
	}
	
	public int gibLaenge()
	{
		return laenge;
	}
	
	public int [] gibGeloeschtenKasten()
	{
		return letzter_kasten;
	}
	
	public int [] gibKopf()
	{
		int [] kopf = new int[2];
		kopf[0] = kasten[0][0];
		kopf[1] = kasten[0][1];
		return kopf;
	}
	
	public int [][] gibAlleKasten()
	{
		return kasten;
	}
	
	public int gegenRichtung(int richtung)
	{
		if(richtung == 0)
		{
			return 2;
		}
		else if(richtung == 1)
		{
			return 3;
		}
		else if(richtung == 2)
		{
			return 0;
		}
		else if(richtung == 3)
		{
			return 1;
		}
		return -1;
	}
}
